config = {
  creature:{
    physical: {
      maxEnergy: 20,
      activationValue: 50,
      defaultSpeed: 5,
      maxAge: 50,
      eatFoodLevel: 4,
      mutateFraction: 0.01,
      birthCost: 6,
      birthEnergy: 5
    },
    brain: {
      size: 5,
      complexity: 10,
      oscillatorFrequency: 10
    },
  },
  world: {
    foodReward: 10,
    tileMaxFood: 500,
    tileDefaultFood: 100,
    tileFoodGrowChance: 0.1
  },
  maxPop: 10000,
  timers: {
    preGame: 5000,
    gameStep: 100
  },
}

module.exports = config
