config = require("../config")

worldObj = require("./storageObjects/worldObj")
creatureArr = require("./storageObjects/creatureArr")
Creature = require("./classes/creatureClass")





function setupGame(){
  return new Promise((resolve,reject) => {
    creatureArr = []
    worldObj.clean()

    // TODO: Figure out why this is in set timeout
    setTimeout(() => {
      numCreatures = 10000
      console.log("Spawning "+numCreatures+" creatures")
      for (let index = 0; index < numCreatures; index++) {
        creatureArr.push(new Creature())
      }
    }, 1000)
    setTimeout(() => {

      if (creatureArr.length == 0){
        return reject(false)
      } else {
        return resolve(true)
      }
    }, config.timers.preGame);
  })
}



function gameLoop(){
  return new Promise((resolve,reject) => {
    loop = setInterval(() => {
      deadCreatureCount = 0
      creatureArr.forEach((creature, index) => {
        creature.act()
        if (!creature.alive){
          deadCreatureCount +=1
          creatureArr.splice(index,1)
        }
      })
      console.log("Dead: "+deadCreatureCount)
      console.log("World: "+worldObj.id+" "+worldObj.universe+" "+worldObj.step)
      console.log("Creatures: "+creatureArr.length)
      console.log(new Date)
      if (creatureArr.length == 0){
        console.log("All Dead")
        clearInterval(loop)
        return resolve(true)
      } else {
        console.log(creatureArr[0].fullName,creatureArr[0].energy+"/"+creatureArr[0].maxEnergy, creatureArr[0].age+"/"+creatureArr[0].maxAge, creatureArr[0].generation)
      }
      worldObj.step += 1
    }, config.timers.gameStep)
  })
}

function recurse(){
  setupGame().then(() => {
    gameLoop().then(()=> {
      // process.exit()
      recurse()
      // gifGen.then(() =>{
      //   
      // })
    })
  }).catch(issue => {
    setTimeout(() => {
      recurse()
    }, config.timers.preGame);
  })
}


recurse()

